import java.util.*;
import java.lang.*;

/* AltriEsercizi8 - esercizio5 del 16/5/2016
 Si definisca in Java una tipo astratto per relazioni binarie, su tipi generici,
 come quelle in esercizio1 per valori IMMUTABLE e con le sole operazioni addPair, 
 removePair, isIn. In particolare, si utilizzi l'interfaccia RelazioneJAPI.java 
 nell'omonimo file allegato e si fornisca:\\
 (a) Intestazione della classe;\\
 (b) Stato Concreto;\\
 (c) AF, I;\\
 (d) Definizione dei metodi addPair, removePair, isIn, getUno;\\
 (e) Trattamento degli Additionals (clone, equals, toString, elements);\\
 (f) Una versione adatta dei casi d'uso discussi in esercizio1.
 */

class RelazioneADTX<A,B> implements Cloneable, RelazioneJAPI<A,B>{
    private Vector<ImPairADTX<A,B>> rep;
    // punto (c)
    // Let {(x,y)| x\in[A], y\in[B]} un valore astratto (vedi interfaccia RelazioneJAPI<A,B>)
    // Then:
    // AF(c) = {(x,y) | (x,y)=c.rep.get(i) (for i\in[0..c.rep.size()-1])}
    // I(c) = (for i,j\in[0..c.rep.size()-1]) if (i!=j) then !(c.rep.get(i).equals(c.rep.get(j)).
    
    public RelazioneADTX(){
        rep = new Vector<ImPairADTX<A,B>>();
    }
    public RelazioneADTX<A,B> addPair(A x, B y) throws invalidArgException{
        if (isIn(x,y)) return this;
        ImPairADTX<A,B> p = new ImPairADTX<A,B>(x,y);
        RelazioneADTX<A,B> res = (RelazioneADTX<A,B>) super.clone();
        res.rep = (Vector<ImPairADTX<A,B>>)rep.clone();
        res.rep.add(p);
        return res;
    }
    public RelazioneJAPI<A,B> removePair (A x, B y) throws invalidArgException{
    //Solleva eccezione se (x=null)||(y=null)
    //calcola Va tale che:
    // (1) forall(u,v), if Va.isIn(u,v) then this.isIn(u,v)
    // (2) if this.isIn(u,v) && !Va.isIn(u,v) then (u,v)=(x,y)
        if (!isIn(x,y)) return this;
        ImPairADTX<A,B> p = new ImPairADTX<A,B>(x,y);
        RelazioneADTX<A,B> res = (RelazioneADTX<A,B>) super.clone();
        res.rep = (Vector<ImPairADTX<A,B>>)rep.clone();
        res.rep.remove(p);
        return res;
    }
    public boolean isIn(A x, B y) throws invalidArgException;
    //Solleva eccezione se (x=null)||(y=null)
    //calcola true sse (x,y)\in Va(this)
    public LinkedList<A> getUno(B y) throws invalidArgException;
    //Solleva eccezione se (x=null)||(y=null)
    //calcola L tale che:
    // isIn(x,y)  sse  x=L.get(i) for i\in[0..L.size()-1]
    //ADDITIONAL (equals, clone, elements, toString)
    public boolean equals(Object r){
        RelazioneADTX<A,B> ok = new RelazioneADTX<A,B>();
        try{ok = (RelazioneADTX<A,B>)r;}
        catch(Exception e){return false;}
        if(rep.size()!=ok.rep.size()) return false;
        /*
        for(ImPairADTX<A,B> u: ok.rep){
            if(!isIn(u.getLeft(),u.getRight())return false;
        }
        
        for(ImPairADTX<A,B> u: ok.rep){
            if(!rep.contains(u)) return false;
         */
        for(int i=0;i<rep.size();i++){
            boolean check=false;
            for(int j=0;i<rep.size();i++){
                check=check|(rep.get(i).equals(ok.rep.get(j)));
            }
            if(!check) return false;
        }
        return true;
    }
    //clone ereditata.
    //elements da scrivere
    //toString da scrivere
    //Caso di uso da scrivere
}
