import java.util.*;

/* Un API COMPLETA per relazioni IMMUTABLE presentata il 17/5/2016
*/

class invalidArgException extends Exception{
}

interface RelazioneJAPI<A,B> extends Cloneable{
    //Introduce Valori Astratti {(x,y)| x\in[A], y\in[B]}
    //Sia O un oggetto di elazioneJAPI<A,B>, Va(O) \`e il valore astratto definito da O.
    public RelazioneJAPI<A,B> addPair(A x, B y) throws invalidArgException;
        //Solleva eccezione se (x=null)||(y=null)
        //calcola Va tale che:
        // (1) forall(u,v), if this.isIn(u,v) then Va.isIn(u,v)
        // (2) if !this.isIn(u,v) && Va.isIn(u,v) then (u,v)=(x,y)
    public RelazioneJAPI<A,B> removePair (A x, B y) throws invalidArgException;
        //Solleva eccezione se (x=null)||(y=null)
        //calcola Va tale che:
        // (1) forall(u,v), if Va.isIn(u,v) then this.isIn(u,v)
        // (2) if this.isIn(u,v) && !Va.isIn(u,v) then (u,v)=(x,y)
    public boolean isIn(A x, B y) throws invalidArgException;
        //Solleva eccezione se (x=null)||(y=null)
        //calcola true sse (x,y)\in Va(this)
    public LinkedList<A> getUno(B y) throws invalidArgException;
        //Solleva eccezione se (x=null)||(y=null)
        //calcola L tale che:
        // isIn(x,y)  sse  x=L.get(i) for i\in[0..L.size()-1]
    //ADDITIONAL (equals, clone, elements, toString)  
}
